// RegReadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RegRead.h"
#include "RegReadDlg.h"

#include "..\..\include\AdamRtuCE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegReadDlg dialog

CRegReadDlg::CRegReadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegReadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegReadDlg)
	m_strDeviceID = _T("");
	m_strDLLVersion = _T("");
	m_strNoOfRead = _T("");
	m_strStartAddress = _T("");
	m_strCOMPort = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegReadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegReadDlg)
	DDX_Text(pDX, IDC_EDIT_DEVICEID, m_strDeviceID);
	DDX_Text(pDX, IDC_EDIT_DLLVER, m_strDLLVersion);
	DDX_Text(pDX, IDC_EDIT_NOOFREAD, m_strNoOfRead);
	DDX_Text(pDX, IDC_EDIT_STARTADDRESS, m_strStartAddress);
	DDX_CBString(pDX, IDC_COMPORT, m_strCOMPort);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegReadDlg, CDialog)
	//{{AFX_MSG_MAP(CRegReadDlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_READREGISTER, OnReadregister)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegReadDlg message handlers

BOOL CRegReadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_strCOMPort="1";
	m_strDeviceID="1";
	m_strStartAddress="1";
	m_strNoOfRead="8";

	SetDlgItemText(IDC_COMPORT,m_strCOMPort);
	SetDlgItemText(IDC_EDIT_DEVICEID,m_strDeviceID);
	SetDlgItemText(IDC_EDIT_STARTADDRESS,m_strStartAddress);
	SetDlgItemText(IDC_EDIT_NOOFREAD,m_strNoOfRead);

	// get the DLL version 
	char     szCh[20];
    int     iVersion;    
 
	iVersion=ADAMRTU_GetDLLVersion();
	_ltoa( iVersion, szCh, 16 );

	size_t len = strlen (szCh);
	wchar_t  wcConverter[20];

	memset (wcConverter, 0, sizeof(wcConverter));
	mbstowcs(wcConverter, szCh, len);
	SetDlgItemText(IDC_EDIT_DLLVER, wcConverter);  
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CRegReadDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
    CDialog::OnOK();	
}

void CRegReadDlg::OnReadregister() 
{
	// TODO: Add your control notification handler code here
    CString   strText,strTemp;
	int       i,j,iRetVal;
	WORD      wDeviceID;
    WORD      wStartAddress;
    WORD      wCount;
    WORD      wData[64];  
	TCHAR	  szwTemp[80];
	int       iComPort,iBaudRate,iTimeout;
    long      lPortHandle;

    //iComPort=2;
    iBaudRate=9600;
	iTimeout=1000;   // timeout interval: 1000 mSec

	// which COM port to use 
	GetDlgItemText(IDC_COMPORT,szwTemp, 80*sizeof(TCHAR));
	iComPort = (unsigned short)_wtoi(szwTemp);

    lPortHandle = ADAMRTU_Open(iComPort);
    if (lPortHandle == (long)INVALID_HANDLE_VALUE)
    {
        MessageBox(_T("ADAM_Open() Failure !!!"));
        return;            
    }      

    iRetVal=ADAMRTU_SetCommState(lPortHandle, iBaudRate, 
                                 ADAMRTU_PARITY_NO, DATEBITS_8, STOPBIT_1);
	if( iRetVal!=0 )
	{
        MessageBox(_T("ADAM_SetCoommState() Failure !!!"));
        ADAMRTU_Close(lPortHandle);		
		return;
	}

	// How many registers to read
	GetDlgItemText(IDC_EDIT_NOOFREAD,szwTemp, 80*sizeof(TCHAR));	
	wCount = (unsigned short)_wtoi(szwTemp);
	if( wCount<0 || wCount>64 )
	{
		MessageBox( _T("The # of Coil must between 1 to 64 !") );
		return;
	}

	// the Device ID
	GetDlgItemText(IDC_EDIT_DEVICEID,szwTemp, 80*sizeof(TCHAR));
	wDeviceID = (unsigned short)_wtoi(szwTemp);

	// the start address to read
	//-- Notice: the address start at 1 instead of 40001
	GetDlgItemText(IDC_EDIT_STARTADDRESS,szwTemp, 80*sizeof(TCHAR));
	wStartAddress = (unsigned short)_wtoi(szwTemp);

    //--- reading the registers ---
    iRetVal=ADAMRTU_ReadHoldingRegister(lPortHandle, wDeviceID, wStartAddress, wCount, wData, iTimeout);

	((CListBox*)GetDlgItem(IDC_LIST_REGISTERVALUE))->ResetContent();
	for(i=0,j=wStartAddress; i<wCount; i++,j++)
	{
		strText.Format( _T("Address:%d   Value(Dec):%d   Value(Hex):%04x"), j,wData[i],wData[i]);
		((CListBox*)GetDlgItem(IDC_LIST_REGISTERVALUE))->InsertString( -1, strText );
	}	

	iRetVal=ADAMRTU_Close(lPortHandle);
    if( iRetVal )
    {
	   MessageBox( _T("Failure to ADAMRTU_Close()") );
	   return;
    }
}
